Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1764)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! +cpl_parent_id,
+! cpp-statements for nesting replaced by __parallel statements,
+! errors output with message-subroutine,
+! index bugfixes in pmci_interp_tril_all,
+! some adjustments to PALM style
 !
 ! Former revisions:
@@ -35,71 +39,93 @@
 !------------------------------------------------------------------------------!
 
-
-    USE mpi
-
-!
-!-- PALM modules
+    USE arrays_3d,                                                             &
+        ONLY:  dzu, dzw, e, e_p, pt, pt_p, q, q_p, te_m, tu_m, tv_m, tw_m, u,  &
+               u_p, v, v_p, w, w_p, zu, zw, z0
+
+    USE control_parameters,                                                    &
+        ONLY:  dt_3d, dz, humidity, message_string, nest_bound_l,              &
+               nest_bound_r, nest_bound_s, nest_bound_n, passive_scalar,       &
+               simulated_time, topography, volume_flow
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nyn, nyng, nys, nysg, &
+               nysv, nz, nzb, nzb_s_inner, nzb_u_inner, nzb_u_outer,           &
+               nzb_v_inner, nzb_v_outer, nzb_w_inner, nzb_w_outer, nzt
+
     USE kinds
-    USE pegrid,                                                                           &
-        ONLY:  myid, numprocs, comm2d, comm1dx, comm1dy, myidx, myidy, collective_wait
-    USE arrays_3d,                                                                        &
-        ONLY:  u, v, w, e, pt, q, u_p, v_p, w_p, e_p, pt_p, q_p, z0, dzu, dzw, zu, zw,    &
-               tu_m, tv_m, tw_m, te_m
-    USE indices,                                                                          &
-        ONLY:  nx, ny, nz, nxl, nxr, nys, nyn, nzb, nzt, nxlu, nysv, nxlg, nxrg,          &
-               nysg, nyng, nbgp, nzb_u_inner, nzb_v_inner, nzb_w_inner,                   &
-               nzb_s_inner, nzb_u_outer, nzb_v_outer, nzb_w_outer
-    USE control_parameters,                                                               &
-        ONLY:  dz, dt_3d, simulated_time, message_string, volume_flow,                    &
-               nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,                    &
-               topography, humidity, passive_scalar
-    USE grid_variables,                                                                   &
-        ONLY:  dx, dy
-    USE cpulog,                                                                           &
-        ONLY:  cpu_log, log_point_s
-
-!
-!-- PMC modules
-    USE pmc_general,                                                                      &
-        ONLY:  pmc_status_ok, pmc_max_modell, da_namelen
-    USE pmc_handle_communicator,                                                          &
-        ONLY:  pmc_init_model, pmc_is_rootmodel, pmc_get_local_model_info,                &
-               pmc_server_for_client
-    USE pmc_mpi_Wrapper,                                                                  &
-        ONLY:  pmc_recv_from_client, pmc_send_to_server, pmc_recv_from_server,            &
-               pmc_send_to_client, pmc_bcast
-    USE pmc_server,                                                                       &
-        ONLY:  pmc_serverinit, pmc_s_getnextarray,                                        &
-               pmc_s_set_dataarray, pmc_s_setind_and_allocmem,                            &
-               pmc_s_set_2d_index_list, pmc_s_fillbuffer,pmc_s_getdata_from_buffer
-    USE pmc_client,                                                                       &
-        ONLY:  pmc_clientinit, pmc_set_dataarray_name, pmc_c_get_2d_index_list,           &
-               pmc_c_getnextarray, pmc_c_set_dataarray, pmc_c_setind_and_allocmem,        &
-               pmc_c_putbuffer, pmc_c_getbuffer
+
+#if defined( __parallel )
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm1dy, comm2d, myid, myidx, myidy,  &
+               numprocs
+
+    USE pmc_client,                                                            &
+        ONLY:  pmc_clientinit, pmc_c_getnextarray, pmc_c_get_2d_index_list,    &
+               pmc_c_getbuffer, pmc_c_putbuffer, pmc_c_setind_and_allocmem,    &
+               pmc_c_set_dataarray, pmc_set_dataarray_name
+
+    USE pmc_general,                                                           &
+        ONLY:  da_namelen, pmc_max_modell, pmc_status_ok
+
+    USE pmc_handle_communicator,                                               &
+        ONLY:  pmc_get_local_model_info, pmc_init_model, pmc_is_rootmodel,     &
+               pmc_no_namelist_found, pmc_server_for_client
+
+    USE pmc_mpi_wrapper,                                                       &
+        ONLY:  pmc_bcast, pmc_recv_from_client, pmc_recv_from_server,          &
+               pmc_send_to_client, pmc_send_to_server
+
+    USE pmc_server,                                                            &
+        ONLY:  pmc_serverinit, pmc_s_fillbuffer, pmc_s_getdata_from_buffer,    &
+               pmc_s_getnextarray, pmc_s_setind_and_allocmem,                  &
+               pmc_s_set_dataarray, pmc_s_set_2d_index_list
+
+#endif
 
     IMPLICIT NONE
 
+!-- TO_DO: a lot of lines (including comments) in this file exceed the 80 char
+!--        limit. Try to reduce as much as possible
+
+!-- TO_DO: shouldn't we use public as default here? Only a minority of the
+!-- variables is private.
     PRIVATE    !:  Note that the default publicity is here set to private.
 
 !
 !-- Constants
-    INTEGER(iwp), PARAMETER, PUBLIC        ::  client_to_server = 2   !:
-    INTEGER(iwp), PARAMETER, PUBLIC        ::  server_to_client = 1   !:
+    INTEGER(iwp), PARAMETER, PUBLIC ::  client_to_server = 2   !:
+    INTEGER(iwp), PARAMETER, PUBLIC ::  server_to_client = 1   !:
 
 !
 !-- Coupler setup
-    INTEGER(iwp), PUBLIC, SAVE             ::  cpl_id                 !:
-    CHARACTER(LEN=32), PUBLIC, SAVE        ::  cpl_name               !:
-    INTEGER(iwp), PUBLIC, SAVE             ::  cpl_npex               !: 
-    INTEGER(iwp), PUBLIC, SAVE             ::  cpl_npey               !:
+    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_id  = 1            !:
+    CHARACTER(LEN=32), PUBLIC, SAVE ::  cpl_name               !:
+    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_npex               !:
+    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_npey               !:
+    INTEGER(iwp), PUBLIC, SAVE      ::  cpl_parent_id          !:
 
 !
 !-- Control parameters, will be made input parameters later
-    CHARACTER(LEN=7), PUBLIC, SAVE         ::  nesting_mode = 'two-way'          !:
-    REAL(wp), PUBLIC, SAVE                 ::  anterp_relax_length_l = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE                 ::  anterp_relax_length_r = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE                 ::  anterp_relax_length_s = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE                 ::  anterp_relax_length_n = -1.0_wp   !:
-    REAL(wp), PUBLIC, SAVE                 ::  anterp_relax_length_t = -1.0_wp   !:
+    CHARACTER(LEN=7), PUBLIC, SAVE ::  nesting_mode = 'two-way'  !: steering parameter for one- or two-way nesting
+
+    LOGICAL, PUBLIC, SAVE ::  nested_run = .FALSE.  !: general switch if nested run or not
+
+    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_l = -1.0_wp   !:
+    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_r = -1.0_wp   !:
+    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_s = -1.0_wp   !:
+    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_n = -1.0_wp   !:
+    REAL(wp), PUBLIC, SAVE ::  anterp_relax_length_t = -1.0_wp   !:
 
 !
@@ -120,5 +146,5 @@
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET, PUBLIC ::  qc   !:
 
-    INTEGER(iwp), DIMENSION(5)                          ::  coarse_bound   !: Moved here form map_fine_to_coarse.
+    INTEGER(iwp), DIMENSION(5)                          ::  coarse_bound   !:
     REAL(wp), PUBLIC, SAVE                              ::  xexl           !:
     REAL(wp), PUBLIC, SAVE                              ::  xexr           !:
@@ -229,5 +255,5 @@
        INTEGER(iwp)                        ::  nx
        INTEGER(iwp)                        ::  ny
-       INTEGER (iwp)                       ::  nz
+       INTEGER(iwp)                        ::  nz
        REAL(wp)                            ::  dx
        REAL(wp)                            ::  dy
@@ -247,56 +273,51 @@
     TYPE(coarsegrid_def), SAVE             ::  cg   !:
 
-!
-!-- Interface section.
+
+    INTERFACE pmci_client_datatrans
+       MODULE PROCEDURE pmci_client_datatrans
+    END INTERFACE
+
+    INTERFACE pmci_client_initialize
+       MODULE PROCEDURE pmci_client_initialize
+    END INTERFACE
+
+    INTERFACE pmci_client_synchronize
+       MODULE PROCEDURE pmci_client_synchronize
+    END INTERFACE
+
+    INTERFACE pmci_ensure_nest_mass_conservation
+       MODULE PROCEDURE pmci_ensure_nest_mass_conservation
+    END INTERFACE
+
     INTERFACE pmci_init
        MODULE PROCEDURE pmci_init
     END INTERFACE
-    
+
     INTERFACE pmci_modelconfiguration
        MODULE PROCEDURE pmci_modelconfiguration
     END INTERFACE
-    
+
+    INTERFACE pmci_server_initialize
+       MODULE PROCEDURE pmci_server_initialize
+    END INTERFACE
+
     INTERFACE pmci_server_synchronize
        MODULE PROCEDURE pmci_server_synchronize
     END INTERFACE
-    
-    INTERFACE pmci_client_synchronize
-       MODULE PROCEDURE pmci_client_synchronize
-    END INTERFACE
-    
-    INTERFACE pmci_server_datatrans
-       MODULE PROCEDURE pmci_server_datatrans
-    END INTERFACE
-    
-    INTERFACE pmci_client_datatrans
-       MODULE PROCEDURE pmci_client_datatrans
-    END INTERFACE
-    
+
     INTERFACE pmci_update_new
        MODULE PROCEDURE pmci_update_new
     END INTERFACE
 
-    INTERFACE pmci_ensure_nest_mass_conservation
-       MODULE PROCEDURE pmci_ensure_nest_mass_conservation
-    END INTERFACE
-    
-    INTERFACE pmci_server_initialize
-       MODULE PROCEDURE pmci_server_initialize
-    END INTERFACE
-    
-    INTERFACE pmci_client_initialize
-       MODULE PROCEDURE pmci_client_initialize
-    END INTERFACE
-    
+    PUBLIC pmci_client_datatrans
+    PUBLIC pmci_client_initialize
+    PUBLIC pmci_client_synchronize
+    PUBLIC pmci_ensure_nest_mass_conservation
     PUBLIC pmci_init
     PUBLIC pmci_modelconfiguration
+    PUBLIC pmci_server_datatrans
+    PUBLIC pmci_server_initialize
     PUBLIC pmci_server_synchronize
-    PUBLIC pmci_client_synchronize
-    PUBLIC pmci_server_datatrans
-    PUBLIC pmci_client_datatrans
     PUBLIC pmci_update_new
-    PUBLIC pmci_ensure_nest_mass_conservation
-    PUBLIC pmci_server_initialize
-    PUBLIC pmci_client_initialize
 
 
@@ -305,28 +326,60 @@
 
  SUBROUTINE pmci_init( world_comm )
+
     IMPLICIT NONE
 
-    INTEGER, INTENT(OUT)  ::  world_comm   !:
-
-    INTEGER(iwp)          ::  ierr         !:
-    INTEGER(iwp)          ::  istat        !:
-    INTEGER(iwp)          ::  PMC_status   !:
-
-
-#if defined PMC_ACTIVE
-    CALL pmc_init_model( world_comm, pmc_status )
-    IF ( pmc_status /= pmc_status_ok )  THEN
-       CALL MPI_ABORT( MPI_COMM_WORLD, istat, ierr )
+    INTEGER, INTENT(OUT) ::  world_comm   !:
+
+#if defined( __parallel )
+
+    INTEGER(iwp)         ::  ierr         !:
+    INTEGER(iwp)         ::  istat        !:
+    INTEGER(iwp)         ::  pmc_status   !:
+
+
+    CALL pmc_init_model( world_comm, nesting_mode, pmc_status )
+
+    IF ( pmc_status == pmc_no_namelist_found )  THEN
+!
+!--    This is not a nested run
+!
+!--    TO_DO: this wouldn't be required any more?
+       world_comm = MPI_COMM_WORLD
+       cpl_id     = 1
+       cpl_name   = ""
+       cpl_npex   = 2
+       cpl_npey   = 2
+       lower_left_coord_x = 0.0_wp
+       lower_left_coord_y = 0.0_wp
+       RETURN
+    ELSE
+!
+!--    Set the general steering switch which tells PALM that its a nested run
+       nested_run = .TRUE.
     ENDIF
-    CALL pmc_get_local_model_info( my_cpl_id = cpl_id, cpl_name = cpl_name,  npe_x=cpl_npex, npe_y = cpl_npey,  &
-                                   lower_left_x = lower_left_coord_x, lower_left_y = lower_left_coord_y )
+
+    CALL pmc_get_local_model_info( my_cpl_id = cpl_id,                         &
+                                   my_cpl_parent_id = cpl_parent_id,           &
+                                   cpl_name = cpl_name,                        &
+                                   npe_x = cpl_npex, npe_y = cpl_npey,         &
+                                   lower_left_x = lower_left_coord_x,          &
+                                   lower_left_y = lower_left_coord_y )
+!
+!-- Message that communicators for nesting are initialized.
+!-- Attention: myid has been set at the end of pmc_init_model in order to
+!-- guarantee that only PE0 of the root domain does the output.
+    CALL location_message( 'finished', .TRUE. )
+!
+!-- Reset myid to its default value
+    myid = 0
 #else
-    world_comm = MPI_COMM_WORLD
+!
+!-- Nesting cannot be used in serial mode. cpl_id is set to root domain (1)
+!-- because no location messages would be generated otherwise.
+!-- world_comm is given a dummy value to avoid compiler warnings (INTENT(OUT)
+!-- should get an explicit value)
     cpl_id     = 1
-    cpl_name   = ""
-    cpl_npex   = 2
-    cpl_npey   = 2
-    lower_left_coord_x = 0.0_wp
-    lower_left_coord_y = 0.0_wp
+    nested_run = .FALSE.
+    world_comm = 1
 #endif
 
@@ -336,9 +389,12 @@
 
  SUBROUTINE pmci_modelconfiguration
+
     IMPLICIT NONE
 
+    CALL location_message( 'setup the nested model configuration', .FALSE. )
     CALL pmci_setup_coordinates   !:  Compute absolute coordinates valid for all models
-    CALL pmci_setup_client        !:  Initialize PMC Client (Must be called before pmc_palm_SetUp_Server)
+    CALL pmci_setup_client        !:  Initialize PMC Client (Must be called before pmc_setup_server)
     CALL pmci_setup_server        !:  Initialize PMC Server
+    CALL location_message( 'finished', .TRUE. )
 
  END SUBROUTINE pmci_modelconfiguration
@@ -347,4 +403,6 @@
 
  SUBROUTINE pmci_setup_server
+
+#if defined( __parallel )
     IMPLICIT NONE
 
@@ -371,9 +429,10 @@
     
 
-#if defined PMC_ACTIVE
-    CALL pmc_serverinit                                !  Initialize PMC Server
-
-!
-!-- Get coordinates from all Clients.
+!
+!   Initialize the PMC server
+    CALL pmc_serverinit
+
+!
+!-- Get coordinates from all clients
     DO  m = 1, SIZE( pmc_server_for_client ) - 1
        client_id = pmc_server_for_client(m)
@@ -391,5 +450,6 @@
 
 !
-!--       Find the highest client level in the coarse grid for the reduced z transfer
+!--       Find the highest client level in the coarse grid for the reduced z
+!--       transfer
           DO  k = 1, nz                 
              IF ( zw(k) > fval(1) )  THEN
@@ -404,17 +464,20 @@
           ALLOCATE( cl_coord_y(-nbgp:ny_cl+nbgp) )
          
-          CALL pmc_recv_from_client( client_id, cl_coord_x, SIZE( cl_coord_x ), 0, 11, ierr )
-          CALL pmc_recv_from_client( client_id, cl_coord_y, SIZE( cl_coord_y ), 0, 12, ierr )
+          CALL pmc_recv_from_client( client_id, cl_coord_x, SIZE( cl_coord_x ),&
+                                     0, 11, ierr )
+          CALL pmc_recv_from_client( client_id, cl_coord_y, SIZE( cl_coord_y ),&
+                                     0, 12, ierr )
           WRITE ( 0, * )  'receive from pmc Client ', client_id, nx_cl, ny_cl
          
           define_coarse_grid_real(1) = lower_left_coord_x
           define_coarse_grid_real(2) = lower_left_coord_y
-          define_coarse_grid_real(3) = 0                                      !  KK currently not used.
+!--       TO_DO: remove this?
+          define_coarse_grid_real(3) = 0             !  KK currently not used.
           define_coarse_grid_real(4) = 0
           define_coarse_grid_real(5) = dx
           define_coarse_grid_real(6) = dy
-          define_coarse_grid_real(7) = lower_left_coord_x + ( nx + 1 ) * dx   !  AH: corrected 6.2.2015
-          define_coarse_grid_real(8) = lower_left_coord_y + ( ny + 1 ) * dy   !  AH: corrected 6.2.2015
-          define_coarse_grid_real(9) = dz                                     !  AH: added 24.2.2015
+          define_coarse_grid_real(7) = lower_left_coord_x + ( nx + 1 ) * dx
+          define_coarse_grid_real(8) = lower_left_coord_y + ( ny + 1 ) * dy
+          define_coarse_grid_real(9) = dz
 
           define_coarse_grid_int(1)  = nx
@@ -437,14 +500,16 @@
 !
 !--       Send coarse grid information to client
-          CALL pmc_send_to_client( client_id, Define_coarse_grid_real, 9, 0, 21, ierr )
-          CALL pmc_send_to_client( client_id, Define_coarse_grid_int,  3, 0, 22, ierr )
-
-!
-!--       Send local grid to client.
+          CALL pmc_send_to_client( client_id, Define_coarse_grid_real, 9, 0,   &
+                                   21, ierr )
+          CALL pmc_send_to_client( client_id, Define_coarse_grid_int,  3, 0,   &
+                                   22, ierr )
+
+!
+!--       Send local grid to client
           CALL pmc_send_to_client( client_id, coord_x, nx+1+2*nbgp, 0, 24, ierr )
           CALL pmc_send_to_client( client_id, coord_y, ny+1+2*nbgp, 0, 25, ierr )
 
 !
-!--       Also send the dzu-, dzw-, zu- and zw-arrays here.    
+!--       Also send the dzu-, dzw-, zu- and zw-arrays here
           CALL pmc_send_to_client( client_id, dzu, nz_cl + 1, 0, 26, ierr )
           CALL pmc_send_to_client( client_id, dzw, nz_cl + 1, 0, 27, ierr )
@@ -454,12 +519,12 @@
        ENDIF
 
-       CALL MPI_Bcast( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
+       CALL MPI_BCAST( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
        IF ( nomatch /= 0 ) THEN
-          WRITE ( message_string, * )  'Error: nested client domain does not fit ',    &
-                                       'into its server domain'
+          WRITE ( message_string, * )  'Error: nested client domain does ',    &
+                                       'not fit into its server domain'
           CALL message( 'pmc_palm_setup_server', 'PA0XYZ', 1, 2, 0, 6, 0 )
        ENDIF
       
-       CALL MPI_Bcast( nz_cl, 1, MPI_INTEGER, 0, comm2d, ierr )
+       CALL MPI_BCAST( nz_cl, 1, MPI_INTEGER, 0, comm2d, ierr )
        
        CALL pmci_create_index_list
@@ -468,17 +533,17 @@
 !--    Include couple arrays into server content
        DO  WHILE ( pmc_s_getnextarray( client_id, myname ) )
-          CALL pmci_set_array_pointer( myName, client_id = client_id, nz_cl = nz_cl )
+          CALL pmci_set_array_pointer( myname, client_id = client_id,          &
+                                       nz_cl = nz_cl )
        ENDDO
        CALL pmc_s_setind_and_allocmem( client_id )
     ENDDO
 
-#endif
-
-
  CONTAINS
 
 
    SUBROUTINE pmci_create_index_list
+
        IMPLICIT NONE
+
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  coarse_bound_all   !:
        INTEGER(iwp)                               ::  i                  !:
@@ -504,5 +569,6 @@
           CALL pmc_recv_from_client( client_id, size_of_array, 2, 0, 40, ierr )
           ALLOCATE( coarse_bound_all(size_of_array(1),size_of_array(2)) )
-          CALL pmc_recv_from_client( client_id, coarse_bound_all, SIZE( coarse_bound_all ), 0, 41, ierr )
+          CALL pmc_recv_from_client( client_id, coarse_bound_all,              &
+                                     SIZE( coarse_bound_all ), 0, 41, ierr )
 
 !
@@ -519,6 +585,6 @@
           ALLOCATE( index_list(6,ic) )
 
-          CALL MPI_Comm_size( comm1dx, npx, ierr )
-          CALL MPI_Comm_size( comm1dy, npy, ierr )
+          CALL MPI_COMM_SIZE( comm1dx, npx, ierr )
+          CALL MPI_COMM_SIZE( comm1dy, npy, ierr )
 
           nrx = nxr - nxl + 1   !  +1 in index because FORTRAN indexing starts with 1, palm with 0
@@ -532,5 +598,5 @@
                    scoord(1) = px
                    scoord(2) = py
-                   CALL MPI_Cart_rank( comm2d, scoord, server_pe, ierr )
+                   CALL MPI_CART_RANK( comm2d, scoord, server_pe, ierr )
                   
                    ic = ic + 1
@@ -546,5 +612,5 @@
           CALL pmc_s_set_2d_index_list( client_id, index_list(:,1:ic) )
        ELSE
-          ALLOCATE( index_list(6,1) )                                   !  Dummy allocate
+          ALLOCATE( index_list(6,1) )    !  Dummy allocate
           CALL pmc_s_set_2d_index_list( client_id, index_list )
        ENDIF
@@ -554,5 +620,5 @@
      END SUBROUTINE pmci_create_index_list
 
-
+#endif
  END SUBROUTINE pmci_setup_server
 
@@ -560,5 +626,10 @@
 
  SUBROUTINE pmci_setup_client
+
+#if defined( __parallel )
     IMPLICIT NONE
+
+    CHARACTER(LEN=DA_Namelen)  ::  myname     !:
+
     INTEGER(iwp)               ::  i          !:
     INTEGER(iwp)               ::  ierr       !:
@@ -579,9 +650,8 @@
     REAL(wp), DIMENSION(4)     ::  ztt        !:
                                              
-    CHARACTER(LEN=DA_Namelen)  ::  myname     !:
-
-
-#if defined PMC_ACTIVE
-    IF ( .not. pmc_is_rootmodel() )  THEN     !  Root Model does not have Server and is not a client
+
+!-- TO_DO: describe what is happening in this if-clause
+!-- Root Model does not have Server and is not a client
+    IF ( .NOT. pmc_is_rootmodel() )  THEN
        CALL pmc_clientinit
        
@@ -596,10 +666,11 @@
 
 !
-!--    Update this list appropritely and also in create_client_arrays and in pmci_set_array_pointer.
-!--    If a variable is removed, it only has tobe removed from here.
-       CALL pmc_set_dataarray_name( lastentry = .true. )
-
-!
-!--    Send grid to Server
+!--    Update this list appropritely and also in create_client_arrays and in
+!--    pmci_set_array_pointer.
+!--    If a variable is removed, it only has to be removed from here.
+       CALL pmc_set_dataarray_name( lastentry = .TRUE. )
+
+!
+!--    Send grid to server
        val(1)  = nx
        val(2)  = ny
@@ -621,5 +692,7 @@
 
 !
-!--       Receive also the dz-,zu- and zw-arrays here.         
+!--       Receive also the dz-,zu- and zw-arrays here.
+!--       TO_DO: what is the meaning of above comment + remove write statements
+!--              and give this informations in header
           WRITE(0,*) 'Coarse grid from Server '
           WRITE(0,*) 'startx_tot    = ',define_coarse_grid_real(1)
@@ -635,6 +708,6 @@
        ENDIF
 
-       CALL MPI_Bcast( define_coarse_grid_real, 9, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( define_coarse_grid_int,  3, MPI_INTEGER, 0, comm2d, ierr )
+       CALL MPI_BCAST( define_coarse_grid_real, 9, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( define_coarse_grid_int, 3, MPI_INTEGER, 0, comm2d, ierr )
 
        cg%dx = define_coarse_grid_real(5)
@@ -658,6 +731,8 @@
 !--    Get coarse grid coordinates and vales of the z-direction from server
        IF ( myid == 0) THEN
-          CALL pmc_recv_from_server( cg%coord_x, cg%nx + 1 + 2 * nbgp, 0, 24, ierr )
-          CALL pmc_recv_from_server( cg%coord_y, cg%ny + 1 + 2 * nbgp, 0, 25, ierr )         
+          CALL pmc_recv_from_server( cg%coord_x, cg%nx + 1 + 2 * nbgp, 0, 24,  &
+                                     ierr )
+          CALL pmc_recv_from_server( cg%coord_y, cg%ny + 1 + 2 * nbgp, 0, 25,  &
+                                     ierr )
           CALL pmc_recv_from_server( cg%dzu, cg%nz + 1, 0, 26, ierr )
           CALL pmc_recv_from_server( cg%dzw, cg%nz + 1, 0, 27, ierr )
@@ -668,13 +743,14 @@
 !
 !--    and broadcast this information
-       CALL MPI_Bcast( cg%coord_x, cg%nx + 1 + 2 * nbgp, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( cg%coord_y, cg%ny + 1 + 2 * nbgp, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( cg%dzu, cg%nz + 1, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( cg%dzw, cg%nz + 1, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( cg%zu, cg%nz + 2,  MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_Bcast( cg%zw, cg%nz + 2,  MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( cg%coord_x, cg%nx + 1 + 2 * nbgp, MPI_REAL, 0, comm2d,  &
+                       ierr )
+       CALL MPI_BCAST( cg%coord_y, cg%ny + 1 + 2 * nbgp, MPI_REAL, 0, comm2d,  &
+                       ierr )
+       CALL MPI_BCAST( cg%dzu, cg%nz + 1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( cg%dzw, cg%nz + 1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( cg%zu, cg%nz + 2,  MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( cg%zw, cg%nz + 2,  MPI_REAL, 0, comm2d, ierr )
        
        CALL pmci_map_fine_to_coarse_grid
-
        CALL pmc_c_get_2d_index_list
 
@@ -682,10 +758,11 @@
 !--    Include couple arrays into client content.
        DO  WHILE ( pmc_c_getnextarray( myname ) )
-          CALL pmci_create_client_arrays ( myName, icl, icr, jcs, jcn,  cg%nz )   !  Klaus, why the c-arrays are still up to cg%nz??
+!--       TO_DO: Klaus, why the c-arrays are still up to cg%nz??
+          CALL pmci_create_client_arrays ( myname, icl, icr, jcs, jcn, cg%nz )
        ENDDO
        CALL pmc_c_setind_and_allocmem
 
 !
-!--    Precompute interpolation coefficients and client-array indices.
+!--    Precompute interpolation coefficients and client-array indices
        CALL pmci_init_interp_tril
 
@@ -695,10 +772,10 @@
 
 !
-!--    Define the SGS-TKE scaling factor based on the grid-spacing ratio. 
+!--    Define the SGS-TKE scaling factor based on the grid-spacing ratio
        CALL pmci_init_tkefactor
 
 !
 !--    Two-way coupling      
-       IF ( nesting_mode == 'two-way' ) THEN
+       IF ( nesting_mode == 'two-way' )  THEN
           CALL pmci_init_anterp_tophat
        ENDIF
@@ -712,10 +789,8 @@
 
 !
-!--    Why not just simply? test this!
+!--    TO_DO: Why not just simply? test this!
        !area_t_l = ( nx + 1 ) * (ny + 1 ) * dx * dy            
 
-    ENDIF   !  IF ( .not. PMC_is_RootModel ) 
-#endif
-
+    ENDIF
 
  CONTAINS
@@ -723,5 +798,7 @@
 
     SUBROUTINE pmci_map_fine_to_coarse_grid
+
         IMPLICIT NONE
+
         INTEGER(iwp), DIMENSION(5,numprocs)  ::  coarse_bound_all   !:
         INTEGER(iwp), DIMENSION(2)           ::  size_of_array      !:
@@ -730,6 +807,6 @@
         REAL(wp)                             ::  coarse_dy   !:
         REAL(wp)                             ::  loffset     !:
+        REAL(wp)                             ::  noffset     !:
         REAL(wp)                             ::  roffset     !:
-        REAL(wp)                             ::  noffset     !:
         REAL(wp)                             ::  soffset     !:
 
@@ -792,5 +869,5 @@
 !
 !--     Note that MPI_Gather receives data from all processes in the rank order. 
-        CALL MPI_Gather( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5, &
+        CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5, &
                          MPI_INTEGER, 0, comm2d, ierr )
 
@@ -968,5 +1045,6 @@
          DO  i = nxl - 1, nxl
             DO  j = nys, nyn
-               nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i), nzb_v_inner(j,i), nzb_w_inner(j,i) )
+               nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i),   &
+                                        nzb_v_inner(j,i), nzb_w_inner(j,i) )
             ENDDO
          ENDDO
@@ -978,5 +1056,6 @@
          i = nxr + 1
          DO  j = nys, nyn
-            nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i), nzb_v_inner(j,i), nzb_w_inner(j,i) )
+            nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i),      &
+                                     nzb_v_inner(j,i), nzb_w_inner(j,i) )
          ENDDO
          nzt_topo_nestbc_r = nzt_topo_nestbc_r + 1       
@@ -987,5 +1066,6 @@
          DO  j = nys - 1, nys
             DO  i = nxl, nxr
-               nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i), nzb_v_inner(j,i), nzb_w_inner(j,i) )
+               nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i),   &
+                                        nzb_v_inner(j,i), nzb_w_inner(j,i) )
             ENDDO
          ENDDO
@@ -997,5 +1077,6 @@
          j = nyn + 1
          DO  i = nxl, nxr
-            nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i), nzb_v_inner(j,i), nzb_w_inner(j,i) )
+            nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i),      &
+                                     nzb_v_inner(j,i), nzb_w_inner(j,i) )
          ENDDO
          nzt_topo_nestbc_n = nzt_topo_nestbc_n + 1
@@ -1003,8 +1084,13 @@
 
 !
-!--  Then determine the maximum number of near-wall nodes per wall point based on the grid-spacing ratios.
-      nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r, nzt_topo_nestbc_s, nzt_topo_nestbc_n )
-      ni = CEILING( cg%dx / dx ) / 2   !  Note that the outer division must be integer division.
-      nj = CEILING( cg%dy / dy ) / 2   !  Note that the outer division must be integer division.
+!--   Then determine the maximum number of near-wall nodes per wall point based
+!--   on the grid-spacing ratios.
+      nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r,                &
+                          nzt_topo_nestbc_s, nzt_topo_nestbc_n )
+
+!
+!--   Note that the outer division must be integer division.
+      ni = CEILING( cg%dx / dx ) / 2
+      nj = CEILING( cg%dy / dy ) / 2
       nk = 1
       DO  k = 1, nzt_topo_max
@@ -1018,6 +1104,6 @@
 
 !
-!--   First horizontal walls.
-!--   Left boundary.
+!--   First horizontal walls
+!--   Left boundary
       IF ( nest_bound_l )   THEN
          ALLOCATE( logc_u_l(nzb:nzt_topo_nestbc_l, nys:nyn, 1:2) )
@@ -1033,12 +1119,12 @@
 
          DO  j = nys, nyn      
-
-!
-!--         Left boundary for u.
+!
+!--         Left boundary for u
             i   = 0
             kb  = nzb_u_inner(j,i)
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_u_l(k,j,1) = lc
             logc_ratio_u_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
@@ -1046,18 +1132,20 @@
 
 !
-!--         Left boundary for v.
+!--         Left boundary for v
             i   = -1
             kb  =  nzb_v_inner(j,i)
             k   =  kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_v_l(k,j,1) = lc
             logc_ratio_v_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
             lcr(0:ncorr-1) = 1.0_wp
-         ENDDO
-      ENDIF
-
-!
-!--   Right boundary.
+
+         ENDDO
+      ENDIF
+
+!
+!--   Right boundary
       IF ( nest_bound_r )  THEN
          ALLOCATE( logc_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
@@ -1071,6 +1159,5 @@
          direction      = 1
          inc            = 1  
-         DO  j = nys, nyn          
-
+         DO  j = nys, nyn
 !
 !--         Right boundary for u.
